<?php
/**
 *
 *
 * @author Sergey Burkov, http://www.wp3dprinting.com
 * @copyright 2021
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}


add_action( 'admin_menu', 'register_p3d_discount_table_menu_page' );
function register_p3d_discount_table_menu_page() {
	add_menu_page( '3DPrint Discount Table', '3DPrint Discount Table', 'manage_options', 'p3d_discount_table', 'register_p3d_discount_table_menu_page_callback' );
}

function register_p3d_discount_table_menu_page_callback() {
	global $wpdb;

	if ( $_GET['page'] != 'p3d_discount_table' ) return false;
	if ( !current_user_can('administrator') ) return false;
	$redirect = false;

	if (isset( $_POST['action'] ) && $_POST['action']=='update' && !isset($_POST['p3d_discount_table_settings'], $_POST['p3d_discount_table_settings_new']) && check_admin_referer( 'save-settings_' )) { //all removed
		update_option( '3dp_discount_table_settings', array() );
		$redirect = true;
	}
	if ( isset( $_POST['p3d_discount_table_settings'] ) && !empty( $_POST['p3d_discount_table_settings'] ) && check_admin_referer( 'save-settings_' )) {
		$settings_update['discount_table'] = $_POST['p3d_discount_table_settings'];
	        foreach ($settings_update['discount_table'] as $key => $value) {
			$value = array_map('sanitize_text_field', $value);
			$key = intval($key);
			$settings_update['discount_table'][$key] = $value;
		}
	        $settings_update['discount_table'] = $_POST['p3d_discount_table_settings'];
		update_option( '3dp_discount_table_settings', $settings_update );
		$redirect = true;
	}


	$settings = get_option( '3dp_discount_table_settings' );

	if ( isset( $_POST['p3d_discount_table_settings_new'] ) && !empty( $_POST['p3d_discount_table_settings_new'] ) && check_admin_referer( 'save-settings_' )) {

	        $settings_update = $settings;
		foreach ($_POST['p3d_discount_table_settings_new'] as $setting) {
			$settings_update['discount_table'][] = array('qty' => $setting['qty'], 'discount' => $setting['discount']);
		}
	        foreach ($settings_update['discount_table'] as $key => $value) {
			$value = array_map('sanitize_text_field', $value);
			$key = intval($key);
			$settings_update['discount_table'][$key] = $value;
		}
		update_option( '3dp_discount_table_settings', $settings_update );
		$redirect = true;
	}
	if ($redirect) {
		wp_redirect( admin_url( 'admin.php?page=p3d_discount_table' ) );
	}

#print_r(get_option( '3dp_discount_table_settings' ));

?>
<style>
#p3d_discount_table input[type='number']{
	max-width: 5em;
} 
#p3d_discount_table a {
	text-decoration: none;
}
</style>
<script language="javascript">
var add_cnt = 9999;
function addDiscountRule() {
	add_cnt++;
	jQuery('<tr>'+
		'<td>QTY</td><td><input type="number" min="1" name="p3d_discount_table_settings_new['+add_cnt+'][qty]" value="1"></td>'+
		'<td>Discount %</td><td><input type="number" min="0" step="any" name="p3d_discount_table_settings_new['+add_cnt+'][discount]" value="0"></td>'+
		'<td><a href="javascript:void(0);" onclick="jQuery(this).parent().parent().remove();">&cross;</a></td></tr>').appendTo('#p3d_discount_table');
}
</script>
<h2>Discount Table Settings:</h2>
<br>
<form method="post" action="admin.php?page=p3d_discount_table">
<input type="hidden" name="action" value="update">
<?php    wp_nonce_field( 'save-settings_' ); ?>
<table id="p3d_discount_table">
	<?php
	if (isset($settings['discount_table']) && count($settings['discount_table'])) {
		$i=0;

		foreach ($settings['discount_table'] as $qty => $discount) {

		if (!is_array($discount) || !isset($discount['qty'])) {$i++;continue;}

		?>
		<tr>
			<td>
				QTY:
			</td>
			<td>
				<input size="3" type="number" min="1" name="p3d_discount_table_settings[<?php echo $i; ?>][qty]" value="<?php echo esc_attr($discount['qty']);?>">
			</td>

			<td>
				Discount %:
			</td>
			<td>
				<input size="3" type="number" min="0" step="any" name="p3d_discount_table_settings[<?php echo $i; ?>][discount]" value="<?php echo esc_attr($discount['discount']);?>">
			</td>
			<td>
				<a href="javascript:void(0);" onclick="jQuery(this).closest('tr').remove();">&cross;</a>
			</td>
		</tr>
		<?php
		$i++;
		}
		?>
	<?php
	}
	?>
	<tr>
		<td colspan="4" align="center"><button type="button" onclick="addDiscountRule();return false;">ADD</button></td>
	</tr>
</table>
<p class="submit">
	<input type="submit" class="button-primary" value="Save Changes" />
</p>
</form>
<?php
}
?>