var p3d_price_total=0;
var p3d_discounts=[];

window.wp.event_manager.addFilter( 'p3d.calculatePrintingCost', function  (total, product_info) {
	p3d_price_total=total;
	return total;
})

function setDiscounts() {
	for (let key in p3d_discount_table.discount_table) {
		if (p3d_discount_table.discount_table.hasOwnProperty(key)) {
			p3d_discounts[key] = parseFloat(p3d_discount_table.discount_table[key]);
		}
	}
}



function getDiscountByQuantity(qty){
	var discount = 0;
	p3d_discounts.forEach(function(item, index, arr){
			if (qty>=index) {
				discount = item;
			}
	})
	return discount;
}

function updatePriceSingle(qty) {
	var discount = getDiscountByQuantity(qty);
	var product_qty = parseInt(jQuery('#add-cart-container input[name=quantity]').val());
	var price_formatted = accounting.formatMoney(p3d_price_total, p3d.currency_symbol, p3d.price_num_decimals, p3d.thousand_sep, p3d.decimal_sep);
	jQuery('#p3d-total-price').remove();
	if (discount > 0) {
		var discounted_price = p3d_price_total - (p3d_price_total/100 * discount);
		if (discounted_price < p3d.min_price) discounted_price = parseFloat(p3d.min_price);
		var discounted_price_formatted = accounting.formatMoney(discounted_price, p3d.currency_symbol, p3d.price_num_decimals, p3d.thousand_sep, p3d.decimal_sep);

		if (discounted_price < p3d_price_total) {
			var price_html = '<s>'+price_formatted+'</s>&nbsp;'+discounted_price_formatted;
		}
		else {
			var price_html = price_formatted;
		}
		jQuery('.p3d-details span.amount').html(price_html);

		var discounted_price_total = discounted_price * product_qty;
		var discounted_price_total_formatted = accounting.formatMoney(discounted_price_total, p3d.currency_symbol, p3d.price_num_decimals, p3d.thousand_sep, p3d.decimal_sep);
		jQuery('<p id="p3d-total-price"><b>'+p3d_discount_table.text_total_price+'</b>: '+discounted_price_total_formatted+'</p>').insertAfter('.p3d-details p.price');
		
	}
	else {

		var regular_price_total = p3d_price_total * product_qty;
		var regular_price_total_formatted = accounting.formatMoney(regular_price_total, p3d.currency_symbol, p3d.price_num_decimals, p3d.thousand_sep, p3d.decimal_sep);
		jQuery('<p id="p3d-total-price"><b>'+p3d_discount_table.text_total_price+'</b>: '+regular_price_total_formatted+'</p>').insertAfter('.p3d-details p.price');
		jQuery('.p3d-details span.amount').html(price_formatted);
	}
}

function updatePriceBulk() {
	var product_qty = parseInt(jQuery('#add-cart-container input[name=quantity]').val());
	var discount_quantities = [];
	p3d_discounts.forEach(function(item, index, arr){
		 discount_quantities.push(index)
	})
	var output_table = '<table class="p3d-discount-table">';
	output_table += '<tr><td>'+p3d_discount_table.text_qty+'</td><td>'+p3d_discount_table.text_discount+'</td><td>'+p3d_discount_table.text_unit_price+'</td></tr>';
	for (var i=0; i<discount_quantities.length; i++) {
		var qty = discount_quantities[i];
		var discount = getDiscountByQuantity(qty);
		var discounted_price = p3d_price_total - (p3d_price_total/100 * discount);
		if (discounted_price < p3d.min_price) discounted_price = parseFloat(p3d.min_price);
		var discounted_price_formatted = accounting.formatMoney(discounted_price, p3d.currency_symbol, p3d.price_num_decimals, p3d.thousand_sep, p3d.decimal_sep);

		var price_formatted = accounting.formatMoney(p3d_price_total, p3d.currency_symbol, p3d.price_num_decimals, p3d.thousand_sep, p3d.decimal_sep);

		var price_html = '<s>'+price_formatted+'</s> '+discounted_price_formatted;
		output_table += '<tr><td>'+qty+'</td><td>'+discount+'%</td><td>'+discounted_price_formatted+'</td></tr>';
	}

	output_table += '</table>';
	jQuery('table.p3d-discount-table').remove();
	if (jQuery('#p3d-finalize').length>0) {
		jQuery(output_table).prependTo('#p3d-finalize');
	}
	else {
		jQuery(output_table).insertBefore('.p3d-details p.price');
	}
}

function checkUpdateQuantity() {
	var qty = jQuery('#add-cart-container input[name=quantity]').val();
	updatePriceSingle(qty);
	updatePriceBulk();
}

jQuery(document).ready(function( $ ){
	setDiscounts();
	jQuery('#add-cart-container input[name=quantity]').on('change', function(){
		var qty = parseInt(jQuery(this).val());
		updatePriceSingle(qty);
		updatePriceBulk();
	})

	if (typeof(checkUpdateQuantity)=='function') {
		if (typeof(window.wp.event_manager)!='undefined') {
			window.wp.event_manager.addAction( '3dprint.showResponse', checkUpdateQuantity, 10);
		}
	}
});